/* Part of Misnamed Filter (see Misnamed Filter.cpp)
 * by Alex Vallat <www.byalexv.co.uk>
 */
#include "AddressSet.h"

//It does not appear to be possible to reference another dll from a spamihilator plugin.
//So this class is a copy of Configurator.AddressSet, converted to C++
	
MisnamedFilter::AddressSet::AddressSet(void)
{
	AddressPatterns = gcnew List<String^>();
	NamePatterns = gcnew List<String^>();
}
MisnamedFilter::AddressSet::AddressSet(XmlElement^ addressSetElement)
{
	AddressPatterns = gcnew List<String^>();
	NamePatterns = gcnew List<String^>();

	DescriptiveName = addressSetElement->GetAttribute("descriptiveName");
	for each (XmlElement^ addressPatternElement in addressSetElement->SelectNodes("EmailAddressPatterns/EmailAddressPattern"))
	{
		AddressPatterns->Add(addressPatternElement->InnerText);
	}
	for each (XmlElement^ namePatternElement in addressSetElement->SelectNodes("NamePatterns/NamePattern"))
	{
		NamePatterns->Add(namePatternElement->InnerText);
	}
}
XmlElement^ MisnamedFilter::AddressSet::Serialise(XmlDocument^ doc)
{
	XmlElement^ addressSetElement = doc->CreateElement("AddressSet");
	addressSetElement->SetAttribute("descriptiveName", DescriptiveName);
	XmlElement^ addressPatterns = (XmlElement^)addressSetElement->AppendChild(doc->CreateElement("EmailAddressPatterns"));
	for each (String^ pattern in AddressPatterns)
	{
		addressPatterns->AppendChild(doc->CreateElement("EmailAddressPattern"))->InnerText = pattern;
	}

	XmlElement^ namePatterns = (XmlElement^)addressSetElement->AppendChild(doc->CreateElement("NamePatterns"));
	for each (String^ pattern in NamePatterns)
	{
		namePatterns->AppendChild(doc->CreateElement("NamePattern"))->InnerText = pattern;
	}

	return addressSetElement;
}