# Misnamed Filter Installer
# by Alex Vallat <www.byalexv.co.uk>
#
# 2011-09-18: v0.7
#  Updated to Plugin SDK 2.6.1 for compatibility with Spamihilator 0.9.9.58 x64
#
# 2011-04-03: v0.6
#  Fixed bug where learning would stop after first spam message was learnt from
#
# 2010-01-17: v0.5
#  Updated to be compatible with 64 bit Spamihilator, and to use new plugin installer
#
# 2008-05-05: v0.5
#  Updated to install filter version 0.4, and CRT version 9.
#
# 2007-03-11: v0.4
#  Updated to install Misnamed Filter version 0.3, and work with Spamihilator 0.9.9.25
#  Handles per-user and all-user settings file locations,
#  including upgrade migration.
#
# 2007-02-27: v0.3
#  Updated to install Misnamed Filter version 0.2
#  
# 2007-02-06: v0.2
#  Readme.html now uninstalled correctly
#  Microsoft.VC80.CRT installed (not uninstalled, as shared)
# 2007-02-02: v0.1
#  Initial Release (AV)
#
# Source code free for non-commercial use
#
# Please share any improvements or changes
#


!define PRODUCT_NAME "Misnamed Filter"
!define PRODUCT_VERSION "0.7"
!define PRODUCT_PUBLISHER "Alex Vallat"
#!define PRODUCT_WEB_SITE "http://www.byalexv.co.uk/spamihilator/MisnamedFilter.html"

!include "PluginInstaller\PluginInstaller.nsh"

!define PER_USER_SETTINGS_FOLDER "$APPDATA\Spamihilator\plugins\${PRODUCT_NAME}"

OutFile "../Releases/MisnamedFilter-${PRODUCT_VERSION}.exe"

Section Files
	SetOverwrite ifnewer
	${InstallTo64bit}
		File "x64\Release\Misnamed Filter.dll"
		SetOutPath "${SUPPORT_FILES64}"
		File "Configurator\bin\x64\Release\Misnamed Filter.Configurator.exe"
		File "readme.html"
	${EndInstallTo}
	${InstallTo32bit}
		File "Release\Misnamed Filter.dll"
		SetOutPath "${SUPPORT_FILES32}"
		File "Configurator\bin\x86\Release\Misnamed Filter.Configurator.exe"
		File "readme.html"
	${EndInstallTo}

	ClearErrors
	SetRegView 64
	ReadRegDWORD $0 HKLM "SOFTWARE\Spamihilator" "ConfigDir"
	${If} ${Errors}
		/*No 64 bit value, so check for a 32 bit one*/
		SetRegView 32
		ReadRegDWORD $0 HKLM "SOFTWARE\Spamihilator" "ConfigDir"
	${Endif}

	${IfNot} ${Errors}
	${AndIf} $0 = 0
	    /*Per user settings, so create the folder to hold them */
		CreateDirectory "${PER_USER_SETTINGS_FOLDER}"
	${Endif}

	SetOverwrite lastused
SectionEnd

Section un.Files
	${InstallTo64bit}
		Delete /REBOOTOK "Misnamed Filter.dll"
		SetOutPath "${SUPPORT_FILES64}"
		Delete "Misnamed Filter.Configurator.exe"
		Delete "readme.html"
		Delete "Misnamed Filter.settings.xml"
		SetOutPath $TEMP
		RmDir "${SUPPORT_FILES64}"
	${EndInstallTo}
	${InstallTo32bit}
		Delete /REBOOTOK "Misnamed Filter.dll"
		SetOutPath "${SUPPORT_FILES32}"
		Delete "Misnamed Filter.Configurator.exe"
		Delete "readme.html"
		Delete "Misnamed Filter.settings.xml"
		SetOutPath $TEMP
		RmDir "${SUPPORT_FILES32}"
	${EndInstallTo}

	Delete "${PER_USER_SETTINGS_FOLDER}\Misnamed Filter.settings.xml"
	RmDir "${PER_USER_SETTINGS_FOLDER}"
SectionEnd